module dfc.examples.bitmapview.abstapp;

import dfc.examples.bitmapview.basecontrols;

class BaseApp : UserApp {
	this() { super(); }
}

alias Control!(BaseApp) AppControl;

class BaseAppDialog : AppControl.AppWnd {
	this( BaseApp parent ) {
		super( parent, &onCreate );
		addPaintHandler( WM_PAINT, &onPaint );
		addNativeHandler( WM_CLOSE, &exitFunc );
	}

	void onCreate() {
		create( WS_OVERLAPPED|WS_SYSMENU|WS_THICKFRAME|WS_CLIPSIBLINGS|WS_CLIPCHILDREN, 0, "", 100, 100, cast(HWND)null );
	}

	LRESULT onPaint( HDC dc ) {
		RECT rect;
		getClientRect( rect );
		FillRect( dc, &rect, app.getMidlightOneBrush() );
		return cast(LRESULT)0;
	}

	LRESULT exitFunc( WPARAM wparam,LPARAM lparam )
	{
		showWindow( false );
		SetFocus( app.getHwnd() );
		return cast(LRESULT)0;
	}
}



