module dfc.examples.bitmapview.mylib;

template Array( T ) {
	T[] create_1D( int w ) {
		return new T[w];
	}

	T[][] create_2D( int w, int h ) {
		T[][] rv = new T[][h];//new T[w][h];
		for( int i = 0; i < h; i++ ) {
			rv[i] = new T[w];
		}
		return rv;
	}

	T[][][] create_3D( int w, int h, int c ) {
		T[][][] rv = new T[][][c];//new T[w][h][c];
		for( int i = 0; i < c; i++ ) {
			rv[i] = create_2D( w, h );
		}
		return rv;
	}
}

