import win32.com.OLEIDL;
import win32.com.MSHTMHST;
import win32.com.EXDISP;

import std.c.stdio;
import win32.api;
import win32.ole2;
import win32.oleauto;
import dfc.core;

extern(C) IID IID_IDocHostUIHandler;

CLSID LCL_CLSID_WebBrowser = {
0x8856F961,0x340A, 0x11D0, [
0xA9, 0x6B, 0x00, cast(ubyte)0xC0, 0x4F, cast(ubyte)0xD7, 0x05, cast(ubyte)0xA2]
};

IID LCL_IID_IWebBrowser2 = {
0xD30C1661, 0xCDAF, 0x11d0,
[0x8A, 0x3E, 0x00, 0xC0, 0x4F, 0xC9, 0xE2, 0x6E]
} ;

class MyContainer : ComObject, IOleClientSite, IDocHostUIHandler, IOleInPlaceSite, IOleInPlaceFrame
{
	HWND mywnd; // container wnd
	IOleObject  browserObject; // the browser itself

	this() {
	}
extern (Windows):
	HRESULT QueryInterface(IID* riid, void** ppv)
	out(rv) {
		assert( !((rv==S_OK)&&(*ppv == null)) );
	}
	body
	{
//		wchar buf[1024];
//		char[] str;
//		StringFromGUID2( riid, cast(wchar*)buf, buf.length );
//		for( int i = 0; buf[i] > 0; i++ ) {
//			str ~= cast(char)buf[i];
//		}
//		printf( "queryif : %.*s ", str );
		if ( *riid == IID_IUnknown )
		{
//			printf( "IUnknown\n" );
			*ppv = cast(IUnknown)this;
			AddRef();
			return S_OK;
		}
		if ( *riid == IID_IOleClientSite ) {
//			printf( "IOleClientSite\n" );
			*ppv = cast(IOleClientSite)this;
			AddRef();
			return S_OK;
		}
		if ( *riid == IID_IOleInPlaceSite ) {
//			printf( "IOleInPlaceSite\n" );
			*ppv = cast(IOleInPlaceSite)this;
			AddRef();
			return S_OK;
		}
		if ( *riid == IID_IDocHostUIHandler ) {
//			printf( "IDocHostUIHandler\n" );
			*ppv = cast(IDocHostUIHandler)this;
			AddRef();
			return S_OK;
		}
		if ( *riid == IID_IOleInPlaceFrame ) {
//			printf( "IOleInPlaceFrame\n" );
			*ppv = cast(IOleInPlaceFrame)this;
			AddRef();
			return S_OK;
		}
		if ( *riid == IID_IOleInPlaceUIWindow ) {
//			printf( "IOleInPlaceUIWindow\n" );
			*ppv = cast(IOleInPlaceUIWindow)this;
			AddRef();
			return S_OK;
		}
		if ( *riid == IID_IOleWindow ) {
//			printf( "IOleWindow\n" );
			*ppv = cast(IOleWindow)this;
			AddRef();
			return S_OK;
		}

//		printf( "{E_NOINTERFACE}\n" );
		*ppv = null;
		return E_NOINTERFACE;
	}

//    ULONG AddRef()  { return super.AddRef();  }
//    ULONG Release() { return super.Release(); }

// interface IOleClientSite : IUnknown
	HRESULT SaveObject() {
		return E_NOTIMPL;
	}
	HRESULT GetMoniker( DWORD dwAssign, DWORD dwWhichMoniker, IMoniker * ppmk )
	{
		return E_NOTIMPL;
	}
	HRESULT GetContainer( IOleContainer * ppContainer )
	{
		*ppContainer = null;
		return E_NOINTERFACE;
	}
	HRESULT ShowObject()
	{
		return NOERROR;
	}
	HRESULT OnShowWindow( BOOL fShow )
	{
		return E_NOTIMPL;
	}
	HRESULT RequestNewObjectLayout()
	{
		return E_NOTIMPL;
	}

//interface IDocHostUIHandler : IUnknown
	HRESULT ShowContextMenu( DWORD dwID, POINT* ppt, IUnknown pcmdtReserved, IDispatch pdispReserved)
	{
		return S_OK;
	}

	HRESULT GetHostInfo( DOCHOSTUIINFO * pInfo )
	{
		pInfo.cbSize = DOCHOSTUIINFO.sizeof;
		pInfo.dwFlags = DOCHOSTUIFLAG.NO3DBORDER;
		pInfo.dwDoubleClick = DOCHOSTUIDBLCLK.DEFAULT;
		return S_OK;
	}

	HRESULT ShowUI( DWORD dwID, IOleInPlaceActiveObject pActiveObject, IOleCommandTarget pCommandTarget, IOleInPlaceFrame pFrame, IOleInPlaceUIWindow pDoc )
	{
		return S_OK;
	}

	HRESULT HideUI()
	{
		return S_OK;
	}

	HRESULT UpdateUI()
	{
		return S_OK;
	}

	HRESULT EnableModeless( BOOL fEnable )
	{
		return S_OK;
	}

	HRESULT OnDocWindowActivate( BOOL fActivate )
	{
		return S_OK;
	}

	HRESULT OnFrameWindowActivate( BOOL fActivate )
	{
		return S_OK;
	}

	HRESULT ResizeBorder( LPCRECT prcBorder, IOleInPlaceUIWindow pUIWindow, BOOL fRameWindow )
	{
		return S_OK;
	}

	HRESULT TranslateAccelerator( LPMSG lpMsg, GUID * pguidCmdGroup, DWORD nCmdID )
	{
		return S_FALSE;
	}

	HRESULT GetOptionKeyPath( LPOLESTR * pchKey, DWORD dw )
	{
		return S_OK;
	}

	HRESULT GetDropTarget( IDropTarget pDropTarget, IDropTarget * ppDropTarget )
	{
		return S_FALSE;
	}

	HRESULT GetExternal( IDispatch * ppDispatch )
	{
		*ppDispatch = null;
		return S_FALSE;
	}

	HRESULT TranslateUrl( DWORD dwTranslate, OLECHAR * pchURLIn, OLECHAR ** ppchURLOut )
	{
		*ppchURLOut = \0;
		return S_FALSE;
	}

	HRESULT FilterDataObject( IDataObject pDO, IDataObject * ppDORet )
	{
		*ppDORet = null;
		return S_FALSE;
	}

//interface IOleInPlaceSite : IOleWindow
//interface IOleInPlaceFrame : IOleInPlaceUIWindow : IOleWindow

//interface IOleWindow : IUnknown
	HRESULT GetWindow( HWND * phwnd )
	{
		*phwnd = mywnd;
		return S_OK;
	}
	HRESULT ContextSensitiveHelp( BOOL fEnterMode )
	{
		return E_NOTIMPL;
	}
//interface IOleInPlaceSite : IOleWindow
	HRESULT CanInPlaceActivate()
	{
		return S_OK;
	}
	HRESULT OnInPlaceActivate()
	{
		return S_OK;
	}
	HRESULT OnUIActivate()
	{
		return S_OK;
	}
	HRESULT GetWindowContext( IOleInPlaceFrame * ppFrame, IOleInPlaceUIWindow * ppDoc, LPRECT lprcPosRect, LPRECT lprcClipRect, LPOLEINPLACEFRAMEINFO lpFrameInfo )
	{
		*ppFrame = cast(IOleInPlaceFrame)this;
		*ppDoc   = null;
		lpFrameInfo.fMDIApp = FALSE;
		lpFrameInfo.hwndFrame = mywnd;
		lpFrameInfo.haccel = null;
		lpFrameInfo.cAccelEntries = 0;

		return S_OK;
	}
	HRESULT Scroll( SIZE scrollExtant )
	{
		return E_NOTIMPL;
	}
	HRESULT OnUIDeactivate( BOOL fUndoable )
	{
		return S_OK;
	}
	HRESULT OnInPlaceDeactivate()
	{
		return S_OK;
	}
	HRESULT DiscardUndoState()
	{
		return E_NOTIMPL;
	}
	HRESULT DeactivateAndUndo()
	{
		return E_NOTIMPL;
	}
	HRESULT OnPosRectChange( LPCRECT lprcPosRect )
	{
		IOleInPlaceObject	inplace;
		if ( S_OK == browserObject.QueryInterface( &IID_IOleInPlaceObject, cast(void**)&inplace) )
		{
			// Give the browser the dimensions of where it can draw.
			inplace.SetObjectRects( lprcPosRect, lprcPosRect );
		}
		return S_OK;
	}
//interface IOleInPlaceFrame : IOleInPlaceUIWindow : IOleWindow
//interface IOleInPlaceUIWindow : IOleWindow
	HRESULT GetBorder( LPRECT lprectBorder )
	{
		return E_NOTIMPL;
	}
	HRESULT RequestBorderSpace( LPCBORDERWIDTHS pborderwidths )
	{
		return E_NOTIMPL;
	}
	HRESULT SetBorderSpace( LPCBORDERWIDTHS pborderwidths )
	{
		return E_NOTIMPL;
	}
	HRESULT SetActiveObject( IOleInPlaceActiveObject pActiveObject, LPCOLESTR pszObjName )
	{
		return S_OK;
	}

//interface IOleInPlaceFrame : IOleInPlaceUIWindow
	HRESULT InsertMenus( HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths )
	{
		return E_NOTIMPL;
	}
	HRESULT SetMenu( HMENU hmenuShared, HOLEMENU holemenu, HWND hwndActiveObject )
	{
		return S_OK;
	}
	HRESULT RemoveMenus( HMENU hmenuShared )
	{
		return E_NOTIMPL;
	}
	HRESULT SetStatusText( LPCOLESTR pszStatusText )
	{
		return S_OK;
	}
	/*
	HRESULT EnableModeless( BOOL fEnable )
	{
		return E_NOTIMPL;
	}
	*/
	HRESULT TranslateAccelerator( LPMSG lpmsg, WORD wID )
	{
		return E_NOTIMPL;
	}
}

//extern(C) IID IID_IDocHostUIHandler;
class MyWindApp : DApp {
	MyContainer myc     ;
	this(MyContainer myc0) {
		super();
		myc = myc0;
		create(	WS_THICKFRAME | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU,
					0,
					"D-Browser",
					16*32, 14*32 );
		addHandler( WM_SIZE, new ResizeMessageSlot( &onSize ) );
		centerWindow();
	}

	bit active;
	void setActive() { active = true; }

	LRESULT onSize( int width, int height ) {
		if ( active ) {
			setBrowserSize( myc, width, height );
		}
		return cast(LRESULT)0;
	}
}

class FakeStorage : ComObject, IStorage {
extern (Windows):
	HRESULT QueryInterface(IID* riid, void** ppv)
	{
		return E_NOTIMPL;
	}

/*    ULONG AddRef()   {		return ++count;    }
    ULONG Release()    {    	return --count;    }
    ULONG count = 1;		// object reference count
*/
	HRESULT CreateStream( OLECHAR *pwcsName, DWORD grfMode, DWORD reserved1, DWORD reserved2, IStream * ppstm)
	{
		return E_NOTIMPL;
	}
   HRESULT OpenStream( OLECHAR *pwcsName, void *reserved1, DWORD grfMode, DWORD reserved2, IStream * ppstm)
	{
		return E_NOTIMPL;
	}
   HRESULT CreateStorage( OLECHAR *pwcsName, DWORD grfMode, DWORD reserved1, DWORD reserved2, IStorage * ppstg)
	{
		return E_NOTIMPL;
	}
   HRESULT OpenStorage( OLECHAR *pwcsName, IStorage pstgPriority, DWORD grfMode, SNB snbExclude, DWORD reserved, IStorage * ppstg )
	{
		return E_NOTIMPL;
	}
   HRESULT CopyTo( DWORD ciidExclude, IID *rgiidExclude, SNB snbExclude, IStorage pstgDest )
	{
		return E_NOTIMPL;
	}
	HRESULT MoveElementTo( OLECHAR * pwcsName, IStorage pstgDest, OLECHAR *pwcsNewName, DWORD grfFlags )
	{
		return E_NOTIMPL;
	}
	HRESULT Commit( DWORD grfCommitFlags )
	{
		return E_NOTIMPL;
	}
	HRESULT Revert()
	{
		return E_NOTIMPL;
	}
	HRESULT EnumElements( DWORD reserved1, void *reserved2, DWORD reserved3, IEnumSTATSTG * ppenum)
	{
		return E_NOTIMPL;
	}
	HRESULT DestroyElement( OLECHAR * pwcsName )
	{
		return E_NOTIMPL;
	}
	HRESULT RenameElement( OLECHAR *pwcsOldName, OLECHAR *pwcsNewName )
	{
		return E_NOTIMPL;
	}
	HRESULT SetElementTimes( OLECHAR * pwcsName, FILETIME * pctime, FILETIME *patime, FILETIME *pmtime )
	{
		return E_NOTIMPL;
	}
	HRESULT SetClass( REFCLSID clsid ) {
		return S_OK;
	}
	HRESULT SetStateBits( DWORD grfStateBits, DWORD grfMask )
	{
		return E_NOTIMPL;
	}
	HRESULT Stat( STATSTG *pstatstg, DWORD grfStatFlag )
	{
		return E_NOTIMPL;
	}

}

void setBrowserSize( MyContainer myc, int width, int height ){
	IWebBrowser2	webBrowser2;
	IOleObject		browserObject;

	browserObject = myc.browserObject;

	if ( S_OK == browserObject.QueryInterface(&LCL_IID_IWebBrowser2, cast(void**)&webBrowser2)
	)
	{
			webBrowser2.Put_Width( width );
			webBrowser2.Put_Height( height );
			webBrowser2.Release();
	}
}


int setBrowserPage( MyContainer myc, wchar[] url )
{
	HWND hwnd = myc.mywnd;
	IWebBrowser2	webBrowser2;
	VARIANT			myURL;
	IOleObject		browserObject;

	browserObject = myc.browserObject;

	if ( S_OK == browserObject.QueryInterface(&LCL_IID_IWebBrowser2, cast(void**)&webBrowser2)
	)
	{
		VariantInit(&myURL);
		myURL.n1.n2.vt = cast(VARTYPE)VT_BSTR;

		myURL.n1.n2.n3.bstrVal = SysAllocString(url);
		if (!myURL.n1.n2.n3.bstrVal)
		{
			webBrowser2.Release();
			return(-6);
		}

		webBrowser2.Navigate2( &myURL, null, null, null, null);

		VariantClear( &myURL );
		webBrowser2.Release();

		// Success
		return(0);
	}

	return(-5);
}


int openBrowser( MyContainer myc )
{
	IWebBrowser2 webBrowser2;
	IStorage MyIStorage = cast(IStorage)(new FakeStorage());
	RECT rect;
	HRESULT rv;

	if (S_OK ==
			(rv = OleCreate(
					cast(REFCLSID)&LCL_CLSID_WebBrowser,
					cast(REFIID)&IID_IOleObject,
					cast(uint)OLERENDER.DRAW,
					null,
					cast(IOleClientSite)myc,
					MyIStorage,
					cast(void**)&(myc.browserObject)))
	)
	{
		myc.browserObject.SetHostNames( "My Host Name", null );

		GetClientRect( myc.mywnd, &rect );
		printf( "OleCreate worked\n" );

		// Let browser object know that it is embedded in an OLE container.
		if ( (rv = OleSetContainedObject( myc.browserObject, TRUE )) != S_OK )
		{
			printf("OleSetContainedObject failed %d\n", rv);
			return rv;
		}
		rv = -33333;
		if ( (rv = myc.browserObject.DoVerb(
							OLEIVERB_SHOW,
							null,
							cast(IOleClientSite)myc,
							-1,
							myc.mywnd,
							&rect
							)
				) != S_OK )
		{
			printf("DoVerb failed %d\n", rv);
			return rv;
		}
		if (
			 ( rv = myc.browserObject.QueryInterface( &LCL_IID_IWebBrowser2, cast(void**)&webBrowser2)
			 ) != S_OK
			)
		{
			printf("QueryInterface failed %d\n", rv);
			return rv;

		}else{

			webBrowser2.Put_Left( 0);
			webBrowser2.Put_Top( 0);
			webBrowser2.Put_Width( rect.right);
			webBrowser2.Put_Height( rect.bottom);

			webBrowser2.Release();

			// Success
			return 0;
		}
	}
	return rv;
}

extern(Windows) HRESULT OleInitialize(LPVOID pvReserved);
extern(Windows) void OleUninitialize();
extern(Windows) 	HRESULT CoInitializeEx(
  void * pvReserved,  //Reserved
  DWORD dwCoInit      //COINIT value
);

const int COINIT_APARTMENTTHREADED = 2;
//interface IDocHostUIHandler : IUnknown
// interface IOleClientSite : IUnknown
//interface IOleInPlaceSite : IOleWindow
//interface IOleInPlaceFrame : IOleInPlaceUIWindow : IOleWindow
int main( char[][] argv )
{
	if ( OleInitialize(null) != S_OK ) {
		printf("OleInitialize failed\n");
		return -100;
	}

	MyContainer myc = new MyContainer();
	DFC.beginApplication();

	MyWindApp app = new MyWindApp( myc );
	myc.mywnd = app.hwnd;
	app.showWindow( true );
	int hr = openBrowser( myc );
	printf( "open browser %d [0x%x]\n\n", hr, hr );
	if ( hr != 0 ) { return -1; }
	hr = setBrowserPage( myc, "http://www.digitalmars.com/d/index.html" );
	printf( "going to a page ... %d [0x%x]\n\n", hr, hr );
	InvalidateRect( app.getHwnd(), null, true );
	app.setActive();

	DFC.msgLoop();

	OleUninitialize();


	return 0;
}     //


