module winex.winmm;

import winex.dynloader;

alias uint MMRESULT;   /* error return code, 0 means no error */

alias DynFunc!( Windows, MMRESULT, uint ) I_I_Ldr;
alias DynFunc!( Windows, DWORD ) I_V_Ldr;
I_I_Ldr.fp fastTimeBeginPeriod;
I_I_Ldr.fp fastTimeEndPeriod;
I_V_Ldr.fp fastTimeGetTime;


ImportFunc!( Windows, DWORD ) timeGetTime;
ImportFunc!( Windows, MMRESULT, uint ) timeBeginPeriod;
ImportFunc!( Windows, MMRESULT, uint ) timeEndPeriod;

static this()
{
	timeBeginPeriod.use( "winmm.dll", "timeBeginPeriod" );
	timeEndPeriod.use(   "winmm.dll", "timeEndPeriod"   );
	timeGetTime.use(     "winmm.dll", "timeGetTime"     );
	fastTimeBeginPeriod = I_I_Ldr.require( "winmm.dll", "timeBeginPeriod" );
	I_I_Ldr.use( fastTimeEndPeriod,   "winmm.dll", "timeEndPeriod" );
	I_V_Ldr.use( fastTimeGetTime,     "winmm.dll", "timeGetTime" );
}
